using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;

using EnterpriseDT.Net.Ftp;

namespace edtFTPnetCF_Demo
{
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox serverAddress;
		private System.Windows.Forms.TextBox username;
		private System.Windows.Forms.TextBox password;
		private System.Windows.Forms.Button connect;
		private System.Windows.Forms.ListView directory;
		private System.Windows.Forms.ImageList icons;
		private System.Windows.Forms.ColumnHeader nameColumn;
		private System.Windows.Forms.ColumnHeader sizeColumn;
		private System.Windows.Forms.ColumnHeader dateColumn;
		private System.Windows.Forms.SaveFileDialog saveFileDialog;
		private System.Windows.Forms.StatusBar status;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;

        private ExFTPConnection ftp = new ExFTPConnection();
	
		public MainForm()
		{
			InitializeComponent();

			ftp = new ExFTPConnection();
			ftp.LicenseOwner = "trialuser";
            		ftp.LicenseKey = "705-3295-5565-4362";

			ExFTPConnection.LogLevel = EnterpriseDT.Util.Debug.LogLevel.All;
            		ExFTPConnection.LogFile = "ftp.log";

			ftp.Connecting += new FTPConnectionEventHandler(ftp_Connecting);
			ftp.Connected += new FTPConnectionEventHandler(ftp_Connected);
			ftp.ServerDirectoryChanging += new FTPDirectoryEventHandler(ftp_ServerDirectoryChanging);
			ftp.ServerDirectoryChanged += new FTPDirectoryEventHandler(ftp_ServerDirectoryChanged);
			ftp.DirectoryListing += new FTPDirectoryListEventHandler(ftp_DirectoryListing);
			ftp.DirectoryListed += new FTPDirectoryListEventHandler(ftp_DirectoryListed);
			ftp.Downloading += new FTPFileTransferEventHandler(ftp_Downloading);
			ftp.BytesTransferred += new BytesTransferredHandler(ftp_BytesTransferred);
			ftp.Downloaded += new FTPFileTransferEventHandler(ftp_Downloaded);
			ftp.Closed += new FTPConnectionEventHandler(ftp_Closed);
		}

		#region Windows Form Designer generated code

		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
			this.Size = new System.Drawing.Size(300, 265);
			this.label1 = new System.Windows.Forms.Label();
			this.serverAddress = new System.Windows.Forms.TextBox();
			this.username = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.password = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.connect = new System.Windows.Forms.Button();
			this.directory = new System.Windows.Forms.ListView();
			this.icons = new System.Windows.Forms.ImageList();
			this.nameColumn = new System.Windows.Forms.ColumnHeader();
			this.sizeColumn = new System.Windows.Forms.ColumnHeader();
			this.dateColumn = new System.Windows.Forms.ColumnHeader();
			this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
			this.status = new System.Windows.Forms.StatusBar();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(5, 8);
			this.label1.Text = "Server Address";
			// 
			// serverAddress
			// 
			this.serverAddress.Location = new System.Drawing.Point(5, 24);
			this.serverAddress.Size = new System.Drawing.Size(100, 20);
			this.serverAddress.Text = "ftp.microsoft.com";
			// 
			// username
			// 
			this.username.Location = new System.Drawing.Point(5, 60);
			this.username.Size = new System.Drawing.Size(100, 20);
			this.username.Text = "anonymous";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(5, 44);
			this.label2.Text = "Username";
			// 
			// password
			// 
			this.password.Location = new System.Drawing.Point(120, 60);
			this.password.Size = new System.Drawing.Size(100, 20);
			this.password.Text = "edtFTPnetCF@test.com";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(120, 44);
			this.label3.Text = "Password";
			// 
			// connect
			// 
			this.connect.Location = new System.Drawing.Point(120, 12);
			this.connect.Text = "Connect";
			this.connect.Click += new System.EventHandler(this.connect_Click);
			// 
			// directory
			// 
			this.directory.Columns.Add(this.nameColumn);
			this.directory.Columns.Add(this.sizeColumn);
			this.directory.Columns.Add(this.dateColumn);
			this.directory.FullRowSelect = true;
			this.directory.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.directory.Location = new System.Drawing.Point(5, 85);
			this.directory.Size = new System.Drawing.Size(230, 160);
			this.directory.SmallImageList = this.icons;
			this.directory.View = System.Windows.Forms.View.Details;
			this.directory.ItemActivate += new System.EventHandler(this.directory_ItemActivate);
			// 
			// icons
			// 
			this.icons.Images.Add(((System.Drawing.Image)(resources.GetObject("resource"))));
			this.icons.Images.Add(((System.Drawing.Image)(resources.GetObject("resource1"))));
			this.icons.ImageSize = new System.Drawing.Size(16, 16);
			// 
			// nameColumn
			// 
			this.nameColumn.Text = "Name";
			this.nameColumn.Width = 100;
			// 
			// sizeColumn
			// 
			this.sizeColumn.Text = "Size";
			this.sizeColumn.Width = 50;
			// 
			// dateColumn
			// 
			this.dateColumn.Text = "Date";
			this.dateColumn.Width = 80;
			// 
			// saveFileDialog
			// 
			this.saveFileDialog.Filter = "All Files (*.*)|*.*";
			// 
			// status
			// 
			this.status.Location = new System.Drawing.Point(0, 235);
			this.status.Size = new System.Drawing.Size(634, 22);
			this.status.Text = "edtFTPnet/CF Demo Ready";
			
			// 
			// MainForm
			// 
			this.Controls.Add(this.status);
			this.Controls.Add(this.directory);
			this.Controls.Add(this.connect);
			this.Controls.Add(this.password);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.username);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.serverAddress);
			this.Controls.Add(this.label1);
			this.Text = "edtFTPnet/CF Sample";

		}
		#endregion

		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void connect_Click(object sender, System.EventArgs e)
		{
			try
			{
				if (!ftp.IsConnected)
				{
					ftp.ServerAddress = serverAddress.Text;
					ftp.UserName = username.Text;
					ftp.Password = password.Text;

					ftp.Connect();

					RefreshDirectory();

					connect.Text = "Disconnect";
				}
				else
				{
					ftp.Close();
					directory.Items.Clear();
					connect.Text = "Connect";
				}
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
		}

		private void RefreshDirectory()
		{
			try
			{
				FTPFile[] files = ftp.GetFileInfos();
				directory.Items.Clear();
				foreach (FTPFile file in files)
				{
					ListViewItem item = new ListViewItem();
					item.ImageIndex = file.Dir ? 0 : 1;
					item.Text = file.Name;
					if (file.Dir)
						item.SubItems.Add("");
					else
						item.SubItems.Add(file.Size.ToString());
					item.SubItems.Add(file.LastModified.ToString("g"));
					directory.Items.Add(item);
				}
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
		}

		private void directory_ItemActivate(object sender, System.EventArgs e)
		{
			if (directory.SelectedIndices.Count>0)
			{
				int selection = directory.SelectedIndices[0];
				ListViewItem item = directory.Items[selection];
				bool isDirectory = (item.ImageIndex==0);
				if (isDirectory)
				{
					ChangeDirectory(item.Text);
				}
				else
				{
					DownloadFile(item.Text);
				}
			}
		}

		private void ChangeDirectory(string directoryName)
		{
			ftp.ChangeWorkingDirectory(directoryName);
			RefreshDirectory();
		}

		private void DownloadFile(string fileName)
		{
			saveFileDialog.FileName = fileName;
			if (saveFileDialog.ShowDialog()==DialogResult.OK)
			{
				ftp.DownloadFile(saveFileDialog.FileName, fileName);
			}
		}

		private void ftp_Connected(object sender, FTPConnectionEventArgs e)
		{
			if (e.IsConnected)
				status.Text = "Connected to " + e.ServerAddress;
			else
				status.Text = "Could not connect to " + e.ServerAddress;
			Application.DoEvents();
		}

		private void ftp_Connecting(object sender, FTPConnectionEventArgs e)
		{
			status.Text = "Connecting to " + e.ServerAddress;
			Application.DoEvents();
		}

		private void ftp_ServerDirectoryChanging(object sender, FTPDirectoryEventArgs e)
		{
			status.Text = "Changing directory to " + e.NewDirectory;
			Application.DoEvents();
		}

		private void ftp_ServerDirectoryChanged(object sender, FTPDirectoryEventArgs e)
		{
			status.Text = "Directory = " + e.NewDirectory;
			Application.DoEvents();
		}

		private void ftp_DirectoryListing(object sender, FTPDirectoryListEventArgs e)
		{
			status.Text = "Listing directory " + ftp.ServerDirectory;
			Application.DoEvents();
		}

		private void ftp_DirectoryListed(object sender, FTPDirectoryListEventArgs e)
		{
		}

		private void ftp_Downloading(object sender, FTPFileTransferEventArgs e)
		{
			status.Text = "Downloading " + e.RemoteFile + " (0 bytes downloaded)";
			Application.DoEvents();
		}

		private void ftp_BytesTransferred(object sender, BytesTransferredEventArgs e)
		{
			status.Text = "Downloading " + e.RemoteFile + " (" + e.ByteCount + " bytes downloaded)";
			Application.DoEvents();
		}

		private void ftp_Downloaded(object sender, FTPFileTransferEventArgs e)
		{
			status.Text = "Downloaded " + e.RemoteFile;
			Application.DoEvents();
		}

		private void ftp_Closed(object sender, FTPConnectionEventArgs e)
		{
			status.Text = "edtFTPnet/CF Demo Ready";
			Application.DoEvents();
		}
	}
}
